## pandora 0.7.1

=== Makefile ===
# Makefile for pandora panorama gimp plugin

# This tries to build pandora for every version of GIMP installed.
# Unfortunately GIMP doesn't have any standard way of doing that,
# so Pandora has to probe for all these possible versions.

# But starting with GIMP 2.2, it can't do that probe, because
# all possible versions have the same name, gimptool-2.0, even
# if they're really 2.2 or 2.3. See bug 310565; maybe this will
# be solved eventually. Meanwhile, you can only install to whichever
# GIMP comes first in your path.

GIMP_1_2_DIR=${HOME}/.gimp-1.2/plug-ins
GIMP_2_0_DIR=${HOME}/.gimp-2.0/plug-ins
GIMP_2_2_DIR=${HOME}/.gimp-2.2/plug-ins
GIMP_2_3_DIR=${HOME}/.gimp-2.3/plug-ins
GIMP_2_4_DIR=${HOME}/.gimp-2.4/plug-ins

GIMPTOOL_1_2=$(shell which gimptool-1.2)
GIMPTOOL_2_0=$(shell which gimptool-2.0)
GIMPTOOL_2_2=$(shell which gimptool-2.2)
GIMPTOOL_2_3=$(shell which gimptool-2.3)

# We don't need C99, but gcc 3.3 forces it by default, so we don't
# see errors that might kill other people's builds.  Force C89:
export CFLAGS=-std=c89

# Most people will want make install, but this dummy target is for
# people who don't want a makefile to install anything unless asked.
build:
	@echo Type make install to build and install the plugin.
	@echo I will try to install it for every version of GIMP
	@echo you have installed.

install:
	if test -x "${GIMPTOOL_2_0}"; then make install-2.0; fi
	if test -x "${GIMPTOOL_1_2}"; then make ${GIMP_1_2_DIR}/pandora_gen; fi

# pandora-match is experimental and not very useful yet.
# Most people probably shouldn't bother.
debug-all:
	if test -x "${GIMPTOOL_1_2}"; then make debug-1.2; fi
	if test -x "${GIMPTOOL_2_3}"; then make debug-2.3; fi

install-2.0:
	gimptool-2.0 --install-strip pandora_gen.c

install-1.2: ${GIMP_1_2_DIR}/pandora_gen

debug-2.3: ${GIMP_2_3_DIR}/pandora_gen ${GIMP_2_3_DIR}/pandora_match

debug-1.2: ${GIMP_1_2_DIR}/pandora_gen ${GIMP_1_2_DIR}/pandora_match

# pandora_gen stuff

${GIMP_1_2_DIR}/pandora_gen: pandora_gen.c
	mkdir -p ${GIMP_1_2_DIR}
	gimptool-1.2 --install-strip pandora_gen.c


# pandora_match stuff

${GIMP_1_2_DIR}/pandora_match: pandora_match.c
	mkdir -p ${GIMP_1_2_DIR}
	gimptool-1.2 --install-strip pandora_match.c

${GIMP_2_0_DIR}/pandora_match: pandora_match.c
	mkdir -p ${GIMP_2_0_DIR}
	gimptool-2.0 --install-strip pandora_match.c

clean:
	rm -f pandora_match pandora_gen *.o

=== debian/changelog ===
pandora (0.7.1-0ubuntu3) saucy; urgency=low

  * debian/compat: Bump to 9.
  * debian/control:
    - Remove cdbs from Build-Depends.
    - Bump debhelper Build-Depends to (>= 9).
    - Bump Standards-Version to 3.9.4.
    - Add ${misc:Depends} to binary.
  * debian/patches/*: Convert to quilt.
  * debian/rules: Convert to dh sequencer.
  * debian/source/format: Indicate 3.0 (quilt) format.

 -- Logan Rosen <logan@ubuntu.com>  Sun, 09 Jun 2013 19:49:47 -0400

pandora (0.7.1-0ubuntu2) gutsy; urgency=low

  * debian/control: Update maintainer fields according to debian-
    maintainer-field spec.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 15 Aug 2007 08:09:25 +0000

pandora (0.7.1-0ubuntu1) dapper; urgency=low

  * Initial release
  * Added patches/01_makefile.diff to patch the Makefile

 -- Hubert Figuiere <hub@figuiere.net>  Wed, 22 Feb 2006 12:57:17 -0500

=== debian/control ===
Source: pandora
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Hubert Figuiere <hub@figuiere.net>
Build-Depends: debhelper (>= 9), libgimp2.0-dev
Standards-Version: 3.9.4
Homepage: http://www.shallowsky.com/software/pandora/

Package: pandora
Architecture: any
Depends: ${misc:Depends}, gimp (>= 2.0)
Description: GIMP Plugin For Creating Panoramas
 GIMP Plugin that arranges images for creation of
 panoramic images.  Pandora uses gradients, and 
 overlays to blend the images, allowing a seamless
 appearance.

## pandora box-0.14.4

=== Makefile ===
# syd's Makefile
# Copyright (c) 2023, 2024, 2025 Ali Polatel <alip@chesswob.org>
# SPDX-License-Identifier: GPL-3.0

# User variables
# Target, e.g: --target=aarch64-unknown-linux-musl
TARGET=

ARCH=$(shell uname -m)
LIBC=$(shell readlink /lib/ld* | grep -q musl && echo musl || echo gnu)
ALPINE_MMV=3.19
ALPINE_VER=$(ALPINE_MMV).1

# Use cargo-auditable for auditable binaries if available.
# Respect user's choice of CARGO=
CARGO ?= $(shell \
	if which cargo-auditable >/dev/null 2>&1; then \
		printf 'cargo auditable'; \
	else \
		printf 'cargo'; \
	fi)

# Common tools
RM= rm
FIND= find
RSYNC = rsync
GIT = git
INSTALL= install
PREFIX= $(HOME)/.local
BINDIR= bin
MANDIR= share/man
DOCDIR= $(HOME)/src/sydbox.exherbo.org
VIMDIR= share/vim/vimfiles
SCDOC= scdoc
MANDOC= mandoc
PKG_CONFIG= pkg-config

# Emacs
EMACS?= emacs
EMACS_BATCH = $(EMACS) -Q --batch

# Environment variables necessary to link libseccomp statically.
export LIBSECCOMP_LINK_TYPE= static
export LIBSECCOMP_LIB_PATH= $(shell $(PKG_CONFIG) --variable=libdir libseccomp || echo /usr/lib)

export RUST_BACKTRACE=1

# Cargo features and flags
CARGOFLAGS= -j$(shell nproc) --quiet
CARGOFEATS= uring
# CARGONODEF=YesPlease -> CARGOFLAGS+=--no-default-features
ifneq ($(CARGONODEF),)
    CARGOFLAGS+= --no-default-features
endif
CARGOFEATS_DEBUG= $(CARGOFEATS)

PROGRAMS= \
	  syd \
	  syd-aes \
	  syd-asm \
	  syd-aux \
	  syd-bit \
	  syd-cap \
	  syd-cat \
	  syd-cpu \
	  syd-dns \
	  syd-elf \
	  syd-emacs \
	  syd-env \
	  syd-err \
	  syd-exec \
	  syd-fd \
	  syd-fork \
	  syd-hex \
	  syd-info \
	  syd-key \
	  syd-ldd \
	  syd-load \
	  syd-lock \
	  syd-log \
	  syd-ls \
	  syd-mdwe \
	  syd-net \
	  syd-mem \
	  syd-oci \
	  syd-open \
	  syd-path \
	  syd-pds \
	  syd-poc \
	  syd-pty \
	  syd-read \
	  syd-rnd \
	  syd-run \
	  syd-sh \
	  syd-sha \
	  syd-size \
	  syd-stat \
	  syd-sys \
	  syd-test \
	  syd-test-do \
	  syd-tck \
	  syd-tor \
	  syd-tty \
	  syd-x

# Manual pages
MANS1= \
       man/syd.1 \
       man/syd-aes.1 \
       man/syd-asm.1 \
       man/syd-aux.1 \
       man/syd-bit.1 \
       man/syd-cap.1 \
       man/syd-cat.1 \
       man/syd-cpu.1 \
       man/syd-dns.1 \
       man/syd-elf.1 \
       man/syd-emacs.1 \
       man/syd-env.1 \
       man/syd-err.1 \
       man/syd-exec.1 \
       man/syd-fd.1 \
       man/syd-fork.1 \
       man/syd-hex.1 \
       man/syd-info.1 \
       man/syd-key.1 \
       man/syd-ldd.1 \
       man/syd-load.1 \
       man/syd-lock.1 \
       man/syd-log.1 \
       man/syd-ls.1 \
       man/syd-mdwe.1 \
       man/syd-net.1 \
       man/syd-mem.1 \
       man/syd-oci.1 \
       man/syd-open.1 \
       man/syd-path.1 \
       man/syd-pds.1 \
       man/syd-poc.1 \
       man/syd-pty.1 \
       man/syd-read.1 \
       man/syd-rnd.1 \
       man/syd-run.1 \
       man/syd-sh.1 \
       man/syd-sha.1 \
       man/syd-size.1 \
       man/syd-stat.1 \
       man/syd-sys.1 \
       man/syd-test.1 \
       man/syd-tck.1 \
       man/syd-tor.1 \
       man/syd-tty.1 \
       man/syd-x.1
MANS2= \
       man/syd.2
MANS5= \
       man/syd.5
MANS7= \
       man/syd.7 \
       man/sydtutorial.7

MANS= $(MANS1) $(MANS2) $(MANS5) $(MANS7)

HTMLS= $(patsubst man/%.1,target/man/%.1.html,$(MANS1)) \
       $(patsubst man/%.2,target/man/%.2.html,$(MANS2)) \
       $(patsubst man/%.5,target/man/%.5.html,$(MANS5)) \
       $(patsubst man/%.7,target/man/%.7.html,$(MANS7))

# Vim syntax files
VIMS_FTD= \
	  vim/ftdetect/syd.vim
VIMS_SYN= \
	  vim/syntax/syd-3.vim

VIMS= $(VIMS_FTD) $(VIMS_SYN)

PUTFLAGS= -c $(HOME)/.s3cfg.site
PUTFLAGS_HTML= $(PUTFLAGS) \
	       --no-guess-mime-type \
	       --default-mime-type=text/html

all: release

man: $(MANS)

build:
	@echo Using libseccomp library from $(LIBSECCOMP_LIB_PATH)
	#FIXME: Fails to build with:
	#error: could not compile `proc-macro2` (build script)
	#$(CARGO) acl -n
	$(CARGO) deny check
	$(CARGO) clippy $(CARGOFLAGS)
	$(CARGO) build --locked --features $(CARGOFEATS_DEBUG) $(CARGOFLAGS)
	$(CARGO) test
build32:
	env \
		LIBSECCOMP_LINK_TYPE=static \
		LIBSECCOMP_LIB_PATH=/usr/i686-linux-musl/lib \
		LD_LIBRARY_PATH=/usr/i686-linux-musl/lib \
		RUSTFLAGS="-Ctarget-feature=+crt-static" \
		$(CARGO) build \
			--target=i686-unknown-linux-musl \
			--features $(CARGOFEATS) $(CARGOFLAGS)
clean:
	$(CARGO) clean
install32: build32
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(BINDIR)/
	for program in $(PROGRAMS); do \
		$(INSTALL) -pm 0755 target/i686-unknown-linux-musl/release/$$program $(DESTDIR)$(PREFIX)/$(BINDIR)/$$program"32"; \
	done
install: release
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(BINDIR)/
	for program in $(PROGRAMS); do \
		$(INSTALL) -pm 0755 target/release/$$program $(DESTDIR)$(PREFIX)/$(BINDIR)/; \
	done
	$(MAKE) install-man
	$(MAKE) install-vim
cave:
	if test -e /etc/exherbo-release; then \
		$(INSTALL) -pm 0755 dev/cave-force.rb /usr/libexec/cave/commands/force; \
		$(INSTALL) -pm 0755 dev/cave-hide.rb /usr/libexec/cave/commands/hide; \
	fi
debug:
	$(CARGO) build --locked --features $(CARGOFEATS_DEBUG) $(CARGOFLAGS)
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(BINDIR)/
	for program in $(PROGRAMS); do \
		$(INSTALL) -pm 0755 target/debug/$$program $(DESTDIR)$(PREFIX)/$(BINDIR)/; \
	done
	$(MAKE) install-man
	$(MAKE) install-vim
install-man: $(MANS)
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(MANDIR)/
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(MANDIR)/man1/
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(MANDIR)/man2/
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(MANDIR)/man5/
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(MANDIR)/man7/
	for man in $(MANS1); do \
		$(INSTALL) -pm 0644 $$man $(DESTDIR)$(PREFIX)/$(MANDIR)/man1/; \
	done
	for man in $(MANS2); do \
		$(INSTALL) -pm 0644 $$man $(DESTDIR)$(PREFIX)/$(MANDIR)/man2/; \
	done
	for man in $(MANS5); do \
		$(INSTALL) -pm 0644 $$man $(DESTDIR)$(PREFIX)/$(MANDIR)/man5/; \
	done
	for man in $(MANS7); do \
		$(INSTALL) -pm 0644 $$man $(DESTDIR)$(PREFIX)/$(MANDIR)/man7/; \
	done
install-vim: $(VIMS)
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(VIMDIR)/ftdetect
	for f in $(VIMS_FTD); do \
		$(INSTALL) -pm 0644 $$f $(DESTDIR)$(PREFIX)/$(VIMDIR)/ftdetect/; \
	done
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(VIMDIR)/syntax
	for f in $(VIMS_SYN); do \
		$(INSTALL) -pm 0644 $$f $(DESTDIR)$(PREFIX)/$(VIMDIR)/syntax/; \
	done
uninstall:
	for program in $(PROGRAMS); do \
		$(RM) -f $(DESTDIR)$(PREFIX)/$(BINDIR)/$$program; \
	done
	for man in $(MANS1); do \
		$(RM) -f $(DESTDIR)$(PREFIX)/$(MANDIR)/man1/$$man; \
	done
	for man in $(MANS2); do \
		$(RM) -f $(DESTDIR)$(PREFIX)/$(MANDIR)/man2/$$man; \
	done
	for man in $(MANS5); do \
		$(RM) -f $(DESTDIR)$(PREFIX)/$(MANDIR)/man5/$$man; \
	done
	for man in $(MANS7); do \
		$(RM) -f $(DESTDIR)$(PREFIX)/$(MANDIR)/man7/$$man; \
	done
	for f in $(VIMS_FTD); do \
		$(RM) -f $(DESTDIR)$(PREFIX)/$(VIMDIR)/ftdetect/$$f; \
	done
	for f in $(VIMS_SYN); do \
		$(RM) -f $(DESTDIR)$(PREFIX)/$(VIMDIR)/syntax/$$f; \
	done
release:
	@echo Using libseccomp library from $(LIBSECCOMP_LIB_PATH)
	$(CARGO) build --release --locked --features $(CARGOFEATS) $(CARGOFLAGS) $(TARGET)
prof:
	@echo Using libseccomp library from $(LIBSECCOMP_LIB_PATH)
	env RUSTFLAGS='-g -Ctarget-cpu=native -Ctarget-feature=-crt-static' \
		$(CARGO) build --release --locked --features prof $(TARGET)
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/$(BINDIR)/
	for program in $(PROGRAMS); do \
		$(INSTALL) -pm 0755 target/release/$$program $(DESTDIR)$(PREFIX)/$(BINDIR)/; \
	done
audit:
	$(CARGO) audit
bpfclean:
	find bpf -name '*.bpf' -type f -delete
bpfgen:
	/bin/sh -cex 'mkdir -m700 -p bpf; cd bpf; syd -mtrace/allow_unsafe_nocookie:1 -Ebpf'
bpf: bpfgen
	@for bpf in ./bpf/*.bpf; do \
		./dev/scmp-info.sh $$bpf | tee ./bpf/$$(basename $$bpf .bpf).txt; \
	done
check:
	$(CARGO) test $(CARGOFLAGS)
doccheck:
	$(CARGO) test --doc $(CARGOFLAGS)
distcheck:
	env CARGO="$(CARGO)" PATH="$(PWD)/target/release:$(PATH)" \
		./dev/cargo-test.sh --release --features $(CARGOFEATS) $(CARGOFLAGS)
distdebug:
	env CARGO="$(CARGO)" PATH="$(PWD)/target/debug:$(PATH)" \
		./dev/cargo-test.sh --features $(CARGOFEATS) $(CARGOFLAGS)
doc:
	$(CARGO) doc --open
eldoc: dev/lsp2html.def src/syd.el
	lsp2html -d dev/lsp2html.def src/syd.el
	sed -i \
		-e 's|charset=ISO-8859-1|charset=UTF-8|' \
		-e 's|<h1>syd.el|<h1><a href="https://gitlab.exherbo.org/sydbox/sydbox/-/raw/main/lib/src/syd.el">syd.el</a>|' \
		src/syd.el.html
	mkdir -m700 -p doc/auto
	mv src/syd.el.html doc/auto
fmt:
	$(CARGO) fmt
	$(EMACS_BATCH) src/syd.el -l $(CURDIR)/dev/emacs-format-file.el -f emacs-format-function
	$(MAKE) -C lib fmt
lint:
	$(EMACS_BATCH) --no-site-file --directory . -f batch-byte-compile src/syd.el
sec:
	@for bin in target/{debug,release}/syd; do \
		test -e $$bin || continue; \
		./dev/checksec.sh $$bin; \
	done
dist:
	./dev/release.sh
publish:
	$(CARGO) publish
upload: eldoc
	rm -rf target/man
	mkdir -m700 -p target/man
	$(MAKE) -j $(HTMLS)
	echo "<!DOCTYPE html><html><head><meta charset=\"UTF-8\"><title>Man Pages Index</title></head><body><h1>man.exherbo.org</h1>" > target/man/index.html
	@for man in target/man/*.*.html; do \
		filename=$${man##*/} ;\
		basename=$${filename%.html}; \
		echo "<a href=\"$$filename\">$$basename</a><br>" ;\
	done | sort >> target/man/index.html
	echo "</body></html>" >> target/man/index.html
	s3cmd put $(PUTFLAGS_HTML) -P target/man/*.html s3://man.exherbo.org/
	s3cmd put $(PUTFLAGS_HTML) -P doc/auto/syd.el.html s3://sydel.exherbo.org/index.html

# Library
lib:
	$(MAKE) -C lib all
checklib:
	$(MAKE) -C lib check

# Fuzzing
fuzz:
	$(MAKE) -C fuzz all
fuzz_conf:
	$(MAKE) -C fuzz $@
fuzz_path:
	$(MAKE) -C fuzz $@

# Use LLVM sanitizers
sanitize_address:
	env RUSTFLAGS="-Zsanitizer=address -Ctarget-feature=-crt-static" $(CARGO) build --release --no-default-features $(CARGOFLAGS) -Zbuild-std=std,panic_abort --target $(ARCH)-unknown-linux-$(LIBC)
sanitize_leak:
	env RUSTFLAGS="-Zsanitizer=leak -Ctarget-feature=-crt-static" $(CARGO) build --release --no-default-features $(CARGOFLAGS) -Zbuild-std=std,panic_abort --target $(ARCH)-unknown-linux-$(LIBC)
sanitize_memory:
	env RUSTFLAGS="-Zsanitizer=memory -Ctarget-feature=-crt-static" $(CARGO) build --release --no-default-features $(CARGOFLAGS) -Zbuild-std=std,panic_abort --target $(ARCH)-unknown-linux-$(LIBC)
sanitize_thread:
	env RUSTFLAGS="-Zsanitizer=thread -Ctarget-feature=-crt-static" $(CARGO) build --release --no-default-features $(CARGOFLAGS) -Zbuild-std=std,panic_abort --target $(ARCH)-unknown-linux-$(LIBC)

bench:
	$(CARGO) bench $(CARGOFLAGS)
bloat:
	$(CARGO) bloat --crates -n 25 --bin syd --profile release
cov:
	$(CARGO) llvm-cov --open
deny:
	$(CARGO) deny --features log,oci,utils,uring check
msrv:
	$(CARGO) msrv --bisect
watch:
	$(CARGO) watch
who:
	@git log --all --format='%cN <%cE>' | sort -u

root: alpine-rootfs.tar.gz
	mkdir -p -m700 $@
	doas tar -C $@ -xpf alpine-rootfs.tar.gz
	doas cp -L /etc/resolv.conf root/etc
	$(PREFIX)/bin/syd --sh | doas tee root/etc/esyd.sh >/dev/null
	doas chmod 644 root/etc/esyd.sh
enter: root
	doas $(PREFIX)/bin/syd -plib -mroot:root

alpine-rootfs.tar.gz:
	wget -cO$@ https://dl-cdn.alpinelinux.org/alpine/v$(ALPINE_MMV)/releases/$(ARCH)/alpine-minirootfs-$(ALPINE_VER)-$(ARCH).tar.gz

aes: dev/aes-ctr

dev/aes-ctr: dev/aes-ctr.c
	astyle $<
	$(CC) -Wall -Wextra $< -o $@ -lssl -lcrypto

ape:
	env -u RUSTFLAGS \
	$(CARGO) +nightly build --release $(CARGOFLAGS) \
		-Zbuild-std=panic_abort,std -Zbuild-std-features="panic_immediate_abort" \
		--target=./dev/$(ARCH)-unknown-linux-cosmo.json \
		--locked --features $(CARGOFEATS),oci

# XXX: This won't work, instead
# 1. Pull cosmopolitan.git
# 2. Build with: build/bootstrap/make -j4 m=optlinux o/optlinux/libc
# 3. Create libc.a with: cd o/optlinux/libc && ar rcs libc.a $(find . -type f -name "*.o")
# 4. Place libc.a under libc/$ARCH-linux-cosmo/lib
libcosmo:
	/bin/sh -exc " \
		rm -rf libcosmo; \
		mkdir -m700 libcosmo; \
		cd libcosmo; \
		wget https://justine.lol/cosmopolitan/cosmopolitan.zip; \
		unzip cosmopolitan.zip; \
		rm -f cosmopolitan.zip; \

## pandora box-0.15.0

=== Makefile ===
--- 
+++ 
@@ -45,8 +45,11 @@
 
 export RUST_BACKTRACE=1
 
+# Pick number of jobs based on CPU count
+JOBS = $(shell nproc)
+
 # Cargo features and flags
-CARGOFLAGS= -j$(shell nproc) --quiet
+CARGOFLAGS= -j$(JOBS) --quiet
 CARGOFEATS= uring
 # CARGONODEF=YesPlease -> CARGOFLAGS+=--no-default-features
 ifneq ($(CARGONODEF),)
@@ -77,7 +80,6 @@
 	  syd-ldd \
 	  syd-load \
 	  syd-lock \
-	  syd-log \
 	  syd-ls \
 	  syd-mdwe \
 	  syd-net \
@@ -127,7 +129,6 @@
        man/syd-ldd.1 \
        man/syd-load.1 \
        man/syd-lock.1 \
-       man/syd-log.1 \
        man/syd-ls.1 \
        man/syd-mdwe.1 \
        man/syd-net.1 \
@@ -280,6 +281,8 @@
 release:
 	@echo Using libseccomp library from $(LIBSECCOMP_LIB_PATH)
 	$(CARGO) build --release --locked --features $(CARGOFEATS) $(CARGOFLAGS) $(TARGET)
+nopie:
+	env RUSTFLAGS="$(RUSTFLAGS) -g -Ctarget-cpu=native -Clink-arg=-no-pie" $(MAKE) release
 prof:
 	@echo Using libseccomp library from $(LIBSECCOMP_LIB_PATH)
 	env RUSTFLAGS='-g -Ctarget-cpu=native -Ctarget-feature=-crt-static' \
@@ -386,6 +389,14 @@
 who:
 	@git log --all --format='%cN <%cE>' | sort -u
 
+cross: cross-mips64el
+
+cross-mips64el:
+	env CROSS_CONTAINER_ENGINE=podman \
+		cross build -j$(JOBS) --release \
+			--target mips64el-unknown-linux-muslabi64 \
+			-Z build-std=std,panic_abort -Zbuild-std-features=panic_immediate_abort
+
 root: alpine-rootfs.tar.gz
 	mkdir -p -m700 $@
 	doas tar -C $@ -xpf alpine-rootfs.tar.gz
@@ -414,13 +425,3 @@
 # XXX: This won't work, instead
 # 1. Pull cosmopolitan.git
 # 2. Build with: build/bootstrap/make -j4 m=optlinux o/optlinux/libc
-# 3. Create libc.a with: cd o/optlinux/libc && ar rcs libc.a $(find . -type f -name "*.o")
-# 4. Place libc.a under libc/$ARCH-linux-cosmo/lib
-libcosmo:
-	/bin/sh -exc " \
-		rm -rf libcosmo; \
-		mkdir -m700 libcosmo; \
-		cd libcosmo; \
-		wget https://justine.lol/cosmopolitan/cosmopolitan.zip; \
-		unzip cosmopolitan.zip; \
-		rm -f cosmopolitan.zip; \

=== lib/Makefile ===
# libsyd: syd /dev/syd interface implementation
# Makefile: Makefile for libsyd
#
# Copyright (c) 2023, 2024 Ali Polatel <alip@chesswob.org>
#
# SPDX-License-Identifier: GPL-3.0

# Package name and version
PACKAGE= syd
VERSION= 3.0.0-alpha.6

# Build profile
PROFILE?= release

# Installation directories
PREFIX = /usr/local
LIB_DIR = $(PREFIX)/lib
MAN_DIR = $(PREFIX)/share/man/man3
INCLUDE_DIR = $(PREFIX)/include

# Cargo and Installer
CARGO?= cargo
INSTALL?= install

# Cargo flags
CARGOFLAGS?= -j$(shell nproc)

# Perl
PERL?= perl
PLSITE?= $(shell $(PERL) -MConfig -e 'print $$Config{installsitelib}')
MANDOC?= mandoc

# Python
PYTHON?= python3
PYSITE?= $(shell $(PYTHON) -c "import site; print(site.getsitepackages()[-1])")

# Source files
SRC=\
    src/lib.rs \
    Cargo.toml

# Library Names
ifeq ($(PROFILE), debug)
	LIB_STATIC= ./target/debug/deps/lib$(PACKAGE).a
	LIB_SHARED= ./target/debug/deps/lib$(PACKAGE).so
else
	LIB_STATIC= ./target/release/deps/lib$(PACKAGE).a
	LIB_SHARED= ./target/release/deps/lib$(PACKAGE).so
endif

# Default target
all: $(LIB_SHARED) $(LIB_STATIC) syd.h

# Publish targets
PUTFLAGS= -c $(HOME)/.s3cfg.site
PUTFLAGS_HTML= $(PUTFLAGS) \
	       --no-guess-mime-type \
	       --default-mime-type=text/html

publish: upload
	$(CARGO) publish --no-verify
upload: doc godoc pldoc pydoc rbdoc
	s3cmd put $(PUTFLAGS_HTML) -P doc/syd/*.html s3://libsyd.exherbo.org/
	s3cmd put $(PUTFLAGS_HTML) -P doc/auto/pl.html s3://plsyd.exherbo.org/index.html
	s3cmd put $(PUTFLAGS_HTML) -P doc/auto/syd.html s3://pysyd.exherbo.org/index.html
	s3cmd put $(PUTFLAGS) -P \
		--no-guess-mime-type \
		--default-mime-type=text/css \
		doc/auto/go/_/css/main.css s3://gosyd.exherbo.org/main.css
	s3cmd put $(PUTFLAGS) -P \
		--no-guess-mime-type \
		--default-mime-type=text/javascript \
		doc/auto/go/_/js/permalink.js s3://gosyd.exherbo.org/permalink.jss
	sed \
		-e 's|../../../../../_/css/main.css|./main.css|' \
		-e 's|../../../../../_/js/permalink.js|./permalink.js|' \
		< 'doc/auto/go/git.sr.ht/~alip/syd/lib/src/index.html' \
		> 'doc/auto/go.html'
	s3cmd put $(PUTFLAGS_HTML) -P doc/auto/go.html s3://gosyd.exherbo.org/index.html
	s3cmd put $(PUTFLAGS_HTML) -P doc/auto/ruby/index.html s3://rbsyd.exherbo.org/index.html

# Documentation targets
doc: syd.h
	gyosu -o doc/syd syd.h
godoc: src/syd.go
	mkdir -m700 -p doc/auto
	rm -rf doc/auto/go
	bash -c "pushd src; exec doc2go ./..."
	mv src/_site doc/auto/go
pldoc: src/syd.pm
	mkdir -m700 -p doc/auto
	bash -c "pushd src && pod2man -u --errors=none syd.pm > ../doc/auto/syd.pm.3"
	$(MANDOC) -Thtml < doc/auto/syd.pm.3 > doc/auto/pl.html
pydoc: $(LIB_SHARED) src/syd.py
	env LD_LIBRARY_PATH=./target/release pdoc -d markdown --output-directory doc/auto src/syd.py
rbdoc: src/syd.rb
	mkdir -m700 -p doc/auto
	rm -rf doc/auto/ruby
	bash -c 'pushd src && yard doc --title "rbsyd: Ruby FFI bindings of libsyd, the syd API C Library" --hide-api private --one-file ./syd.rb'
	mv src/doc doc/auto/ruby

# QA targets
fmt:
	$(CARGO) fmt || true
	black src/syd.py || true
	perltidy -b src/syd.pm src/syd.pl || true
	astyle examples/c/*.c || true
	sh -c "cd src; exec go fmt -x ." || true
	sh -c "cd examples/go; exec go fmt -x ." || true
	rubocop --config ./.rubocop.yml --autocorrect-all src/*.rb examples/ruby/*.rb || true
lint:
	$(CARGO) deny check
	$(CARGO) acl -n || true
	$(CARGO) clippy $(CARGOFLAGS)
	pylint src/syd.py || true
	rubocop --config ./.rubocop.yml --autocorrect-all src/syd.rb || true

# Install and Uninstall Targets
install:
	$(INSTALL) -d $(LIB_DIR)
	$(INSTALL) -m 644 $(LIB_STATIC) $(LIB_DIR)
	$(INSTALL) -m 755 $(LIB_SHARED) $(LIB_DIR)
	$(INSTALL) -d $(INCLUDE_DIR)
	$(INSTALL) -m 644 syd.h $(INCLUDE_DIR)
	$(INSTALL) -d $(MAN_DIR)
	$(INSTALL) -m 644 doc/man/man3/syd.h.3 $(MAN_DIR)
	$(INSTALL) -d $(PLSITE)
	$(INSTALL) -m 755 src/syd.pm $(PLSITE)
	$(INSTALL) -d $(PYSITE)
	$(INSTALL) -m 755 src/syd.py $(PYSITE)
uninstall:
	rm -f $(LIB_DIR)/libsyd.a
	rm -f $(LIB_DIR)/libsyd.so
	rm -f $(INCLUDE_DIR)/syd.h
	rm -f $(MAN_DIR)/syd.h.3
	rm -f $(PLSITE)/syd.pm
	rm -f $(PYSITE)/syd.py

# Check target
check: test

test: $(LIB_SHARED)
	$(CARGO) test --profile=$(PROFILE) $(CARGOFLAGS)

# Clean Target
clean:
	$(CARGO) clean

syd.h: $(SRC) cbindgen.toml
	cbindgen -c cbindgen.toml -o syd.h .
$(LIB_SHARED): $(SRC)
	$(CARGO) build --profile=$(PROFILE) $(CARGOFLAGS)
$(LIB_STATIC): $(SRC)
	$(CARGO) build --profile=$(PROFILE) $(CARGOFLAGS)

# Phony Targets
.PHONY: all clean check doc godoc pldoc pydoc rbdoc test install uninstall publish fmt lint

## pandora box-0.19.0-crates

=== gentoo/lexis-0.2.3/Makefile ===
# lexis' Makefile
# Copyright (c) 2024 Ali Polatel <alip@chesswob.org>
# SPDX-License-Identifier: GPL-3.0-or-later

CARGO= cargo

# Cargo features and flags
CARGOFLAGS= -j$(shell nproc) -v

all: build

build:
	$(CARGO) deny check
	$(CARGO) clippy $(CARGOFLAGS)
	$(CARGO) build --locked $(CARGOFLAGS)
	$(CARGO) test
fmt:
	$(CARGO) fmt
lint:
	$(CARGO) clippy $(CARGOFLAGS)

.PHONY: all build fmt lint

=== gentoo/pathrs-0.2.3/Makefile ===
# SPDX-License-Identifier: MPL-2.0 OR LGPL-3.0-or-later
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 SUSE LLC
# Copyright (C) 2026 Aleksa Sarai <cyphar@cyphar.com>
#
# == MPL-2.0 ==
#
#  This Source Code Form is subject to the terms of the Mozilla Public
#  License, v. 2.0. If a copy of the MPL was not distributed with this
#  file, You can obtain one at https://mozilla.org/MPL/2.0/.
#
# Alternatively, this Source Code Form may also (at your option) be used
# under the terms of the GNU Lesser General Public License Version 3, as
# described below:
#
# == LGPL-3.0-or-later ==
#
#  This program is free software: you can redistribute it and/or modify it
#  under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or (at
#  your option) any later version.
#
#  This program is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
#  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
#  for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this program. If not, see <https://www.gnu.org/licenses/>.

CARGO ?= cargo
CARGO_NIGHTLY ?= cargo +nightly

# Unfortunately --all-features needs to be put after the subcommand, but
# cargo-hack needs to be put before the subcommand. So make a function to make
# this a little easier.
ifneq (, $(shell which cargo-hack))
define cargo_hack
	$(1) hack --feature-powerset $(2)
endef
else
define cargo_hack
	$(1) $(2) --all-features
endef
endif
CARGO_CHECK := $(call cargo_hack,$(CARGO),check)
CARGO_CLIPPY := $(call cargo_hack,$(CARGO),clippy)
CARGO_LLVM_COV := $(call cargo_hack,$(CARGO_NIGHTLY),llvm-cov)

RUSTC_FLAGS := -C panic=abort
CARGO_FLAGS ?= --features=capi

SRC_FILES = $(wildcard Cargo.*) $(shell find . -name '*.rs')

.DEFAULT: debug
.PHONY: debug
debug: target/debug

target/debug: $(SRC_FILES)
	# MSRV(1.64): Use cargo rustc --crate-type={cdy,static}lib.
	RUSTFLAGS="$(RUSTC_FLAGS)" ./hack/with-crate-type.sh $(CARGO) build $(CARGO_FLAGS)
	# For some reason, --crate-type needs separate invocations. We can't use
	# #![crate_type] unfortunately, as using it with #![cfg_attr] has been
	# deprecated. <https://github.com/rust-lang/rust/issues/91632>
	#$(CARGO) rustc $(CARGO_FLAGS) --crate-type=cdylib    $(RUSTC_FLAGS)
	#$(CARGO) rustc $(CARGO_FLAGS) --crate-type=staticlib $(RUSTC_FLAGS)

.PHONY: release
release: target/release

target/release: CARGO_FLAGS += --release
target/release: $(SRC_FILES)
	# MSRV(1.64): Use cargo rustc --crate-type={cdy,static}lib.
	RUSTFLAGS="$(RUSTC_FLAGS)" ./hack/with-crate-type.sh $(CARGO) build $(CARGO_FLAGS)
	# For some reason, --crate-type needs separate invocations. We can't use
	# #![crate_type] unfortunately, as using it with #![cfg_attr] has been
	# deprecated. <https://github.com/rust-lang/rust/issues/91632>
	#$(CARGO) rustc $(CARGO_FLAGS) --crate-type=cdylib    $(RUSTC_FLAGS)
	#$(CARGO) rustc $(CARGO_FLAGS) --crate-type=staticlib $(RUSTC_FLAGS)

.PHONY: smoke-test
smoke-test:
	make -C examples smoke-test

.PHONY: clean
clean:
	-rm -rf target/

.PHONY: lint
lint: validate-cbindgen lint-rust

.PHONY: lint-rust
lint-rust:
	$(CARGO_NIGHTLY) fmt --all -- --check
	$(CARGO_CLIPPY) --all-targets
	$(CARGO_CHECK) $(CARGO_FLAGS) --all-targets

.PHONY: validate-cbindgen
validate-cbindgen:
	$(eval TMPDIR := $(shell mktemp --tmpdir -d libpathrs-cbindgen-check.XXXXXXXX))
	@																		\
		trap "rm -rf $(TMPDIR)" EXIT ;										\
		cbindgen -c cbindgen.toml -o $(TMPDIR)/pathrs.h ;					\
		if ! ( diff -u include/pathrs.h $(TMPDIR)/pathrs.h ); then			\
			echo -e															\
			  "\n"															\
			  "ERROR: include/pathrs.h is out of date.\n\n"					\
			  "Changes to the C API in src/capi/ usually need to be paired with\n" \
			  "an update to include/pathrs.h using cbindgen. To fix this error,\n" \
			  "just run:\n\n"												\
			  "\tcbindgen -c cbindgen.toml -o include/pathrs.h\n" ;			\
			exit 1 ;														\
		 fi

.PHONY: validate-elf-symbols
validate-elf-symbols: release
	./hack/check-elf-symbols.sh ./target/release/libpathrs.so

.PHONY: test-rust-doctest
test-rust-doctest:
	$(CARGO_LLVM_COV) --no-report --branch --doc

.PHONY: test-rust-unpriv
test-rust-unpriv:
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)"
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)" --enosys=openat2
	# In order to avoid re-running the entire test suite with just statx
	# disabled, we re-run the key procfs tests with statx disabled.
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)" --enosys=statx "test(#tests::*procfs*)"

.PHONY: test-rust-root
test-rust-root:
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)" --sudo
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)" --sudo --enosys=openat2
	# In order to avoid re-running the entire test suite with just statx
	# disabled, we re-run the key procfs tests with statx disabled.
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)" --sudo --enosys=statx "test(#tests::*procfs*)"

.PHONY: test-rust
test-rust:
	-rm -rf target/llvm-cov*
	make test-rust-{doctest,unpriv,root}

.PHONY: test-e2e
test-e2e:
	make -C e2e-tests test-all
	make -C e2e-tests RUN_AS=root test-all

.PHONY: test
test: test-rust test-e2e
	$(CARGO_NIGHTLY) llvm-cov report
	$(CARGO_NIGHTLY) llvm-cov report --open

.PHONY: docs
docs:
	$(CARGO) doc --all-features --document-private-items --open

.PHONY: install
install: release
	@echo "If you want to configure the install paths, use ./install.sh directly."
	@echo "[Sleeping for 3 seconds.]"
	@sleep 3s
	./install.sh

=== gentoo/pathrs-0.2.3/examples/rust-cat/Makefile ===
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 SUSE LLC
# Copyright (C) 2026 Aleksa Sarai <cyphar@cyphar.com>
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.

CARGO ?= cargo

EXAMPLE_NAME := $(basename $(shell basename $$PWD))

.PHONY: build
build:
	$(CARGO) build --example $(EXAMPLE_NAME)

.PHONY: smoke-test
smoke-test: build
	../../target/debug/examples/$(EXAMPLE_NAME) . ../../main.rs &>/dev/null
